package net.wanji.com.common.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import net.wanji.com.service.controller.ControlCommandService;
import net.wanji.com.service.controller.SignalStatusService;
import net.wanji.com.service.controller.StaticInfoService;

import java.util.Objects;

/**
 * @author duanruiming
 * @date 2023/05/09 10:35
 */
@Getter
@AllArgsConstructor
@RequiredArgsConstructor
public enum SignalInterfaceTypeEnum {

    CONTROL("control", ControlCommandService.class, "控制类型接口"),

    STATUS("status",SignalStatusService.class, "状态类型接口"),

    STATIC("static",StaticInfoService.class, "静态类型接口");

    private String code;

    private Object type;

    private String desc;

    /**
     * 通过编号获取接口类型
     *
     * @param code
     * @return
     */
    public Object getInterfaceType(String code) {
        for (SignalInterfaceTypeEnum value : SignalInterfaceTypeEnum.values()) {
            if (Objects.equals(code, value.getCode())) {
                return value.getType();
            }
        }
        return null;
    }

}
