package net.wanji.com.netty.response.impl;

import lombok.extern.slf4j.Slf4j;
import net.wanji.com.common.constants.Constants;
import net.wanji.com.netty.NettyClient;
import net.wanji.com.netty.pojo.CommandPojo;
import net.wanji.com.netty.response.CommandResponseFactory;
import net.wanji.com.pojo.netty.MessageResultPojo;
import net.wanji.com.util.CRC16Utils;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;

/**
 * @author duanruiming
 * @date 2023/05/12 11:00
 */
@Service
@Slf4j
public class HeartBeatService implements CommandResponseFactory {
    @Override
    public String getCommandResponse(CommandPojo commandPojo) {
        return commandPojo.getResponseMsg();
    }

    @Scheduled(fixedRate = 1000, initialDelay = 10 * 1000)
    public void heartbeat() {
        String body = String.format("%02x", Constants.COMMAND_HEARTBEAT.length() / 2).concat(Constants.COMMAND_HEARTBEAT);
        String crc16HexStr = CRC16Utils.getCRC16HexStr(body);
        String heartBeatRequest = Constants.buildMessageBody(body, crc16HexStr);
        MessageResultPojo resultPojo2 = NettyClient.sendMessage("10.102.1.204", 4050, heartBeatRequest, "7e00", 300);
        log.info("信号返回字符串：{}", resultPojo2.getHexMessageResult());


//        String str = "55ac00000000000017050f11060b0000000000000000000000000000000000";
//        MessageResultPojo resultPojo = NettyClient.sendMessage("10.102.1.204", 4050, str, "55ab", 300);
//        log.info("信号返回字符串：{}", resultPojo.getHexMessageResult());
    }
}
